.286
text segment byte public
	assume cs:text,ds:text
	org 100h
begin:	

; Stop Windows
;	mov  ax,1681h
;	int  2fh
;	test al,al
;       jz   @WinHere
;	jmp  @GoDos
;@WinHere:
;        mov  ax,0fb01h
;        mov  di,offset InfoArray
;        int  16h
;        jc   @Err
;        nop
;@Err:
;        jmp  @CheckBuff
@TryAgain:
; outportb(0x3F6,0x0A);
	mov  dx,03f6h
        call EnablePort
	mov  al,0ah
	out  dx,al
	call Waiter

; while(inportb(0x1F7)&0x80);
@Wait1:
	mov  dx,01f7h
        call EnablePort
	in   al,dx
	call TimeOut
	test al,80h
	jnz  @Wait1
	call Waiter

; outportb(0x1F6,0xA0+(drive<<4));
	mov  dx,01f6h
        call EnablePort
	mov  al,Drive
	shl  al,4
	add  al,0a0h
	out  dx,al
	call Waiter

; while(!(inportb(0x1F7)&0x40));
@Wait2:
	mov  dx,01f7h
        call EnablePort
	in   al,dx
	call TimeOut 
	test al,40h
	jz   @Wait2
	call Waiter

; outportb(0x1F7,0xEC);
	mov  dx,01f7h
        call EnablePort
	mov  al,0ech
	out  dx,al
	call Waiter

; while(!(inportb(0x1F7)&0x08));
@Wait3:
	mov  dx,01f7h
        call EnablePort
	in   al,dx
	call TimeOut
 	test al,08h
	jz   @Wait3
	call Waiter

; for(i=0; i<256; i++) infoArray[i] = swap(inportw(0x1F0));
ReadInfo:
	mov  cx,256
	mov  di,offset InfoArray
	cld
	push cx
	push di
@FillBuf:
	call Waiter	
	mov  dx,01f0h
        call EnablePort
	in   ax,dx
	xchg al,ah
	stosw	; es:[di] = ax, di:=di+2
	loop @FillBuf
	pop  di
	pop  cx
                                                  
; if(inportb(0x1F7)&0x80) continue;                                           
	mov  dx,01f7h
        call EnablePort
	in   al,dx
	call TimeOut
	test al,80h
        jz   @CheckBuff
;	jnz  @TryAgain
	jmp  @TryAgain
@CheckBuff:
; Check Buffer
	xor  ax,ax
        mov  cx,100h
	rep  scasw
	jnz  @BuffNotEmpty
	mov  dx,offset EmptyMess
	call Message
	jmp  short @GoDos
@BuffNotEmpty:
	mov  dx,offset OKMess
	call Message

	mov  ah,3ch	; File Create
	xor  cx,cx	; Not Attributes
	mov  dx,offset DataFile
	int  21h
	jnc  @FileOpen
	call @Error
	jmp  @GoDos
@FileOpen:
	mov  bx,ax
	mov  ah,40h
	mov  cx,size InfoArray
	mov  dx,offset InfoArray
	int  21h
	jnc  @FileWrite
	call @Error
	jmp  @GoDos
@FileWrite:
	mov  ah,3eh
	int  21h	
@GoDos:
; Enable Windows
;	mov  ax,1682h
;	int  2fh
	ret
TimeOut proc near
	inc  word ptr Counter
	jnz  @Exit
	pop  ax
	call @Error
	jmp  @GoDos
@Exit:  
	retn
Counter dw   0
TimeOut endp
EnablePort proc
;       pusha
;       mov  ax,0030h
;       int  2ch
;       jc   @Quit
;       nop
;@Quit:
;        popa
        retn
EnablePort endp
Waiter  proc near
	push cx
	xor  cx,cx
@Wait:	loop @Wait
	pop  cx
	retn
Waiter  endp
@Error: mov  dx,offset ErrorMess
	call Message
	ret
Message Proc Near
        mov  ah,09h
	int  21h
	ret
Message Endp
Stop Proc Near
@@Stop:
	xor  ah,ah
	int  16h
	cmp  al,27
	jnz  @@Stop
	ret
Stop Endp
DataFile db 'InfArray.txt',0 
ErrorMess db 'Error ! Can"t read Serial Number of You Hard Drive.',13,10,'$'
OKMess db 'Process OK !',13,10,'$'
EmptyMess db 'Buffer is Empty(Info Array) !',13,10,'$'
Drive db 0h
InfoArray dw 256 dup(0)
text ends
	end begin